/*
 *	ff5magic.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2007-2008 Inu
 */

#if !defined(FF5MAGIC_H)
#define FF5MAGIC_H

#include "ff5define.h"

typedef struct magdata_tag
{
	int magic_point;			/* ޥåݥ */
	int effect_type;			/* ˡθ̥ */
	int effect_power;			/*  */
	int effect_rate;			/* Ψ */
	int hit_rate;				/* ̿Ψ */
	int critical_hit_rate;		/* ƥҥåΨ */
	int effect_time;			/* ̻³ */
	int effect_level;			/* оݤȤʤŨΥ٥ */
	int fixed_value;			/*  */
	int time_wait;				/* ޥɼ¹ԸθȯưޤǤλ */
	int attacks_num;			/*  */
	int learning_rate;			/* 顼˥󥰤ǤΨ */
	elem_t elem_effect;			/* ° */
	state_t state_effect;		/* Ѳ */
	montype_t montype_effect;	/* ͭ󥹥 */
	category_t category;		/* ⥫ƥ */

	/* ե饰ϥǡ */
	int flag_reflect;			/* ե쥯ȿͲǽ */

	/* ϰ/о/ */
	int flag_roulette;			/* оݤ롼åȤǷޤ */
	int flag_cure;				/* ƮǽԤоݤˤǤ */
	int direction;				/* ȯư(0: ̣¦, 1: Ũ¦) */
	int range;					/* ϰ(0: ñ, 1: ) */
	int change_target;			/* оݤѲ(0: , 1: ) */
	int change_direction;		/* ȯưѲ(0: , 1: ) */
	int change_range;			/* ϰϤѲ(0: , 1: ) */
	int auto_direction;			/* ȯưʬȤ⤷ϼưŪ˷ꤹ */
} magdata_t;

const char *mag_getname(int index);
magdata_t *mag_readdata(void);
int mag_setparam(magdata_t *ptr_magdata, unsigned char *ptr_buf, size_t bufsize);
int mag_writeparam(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writeelem(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writecategory(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writestate(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writeflag(const char *ptr_filename, const magdata_t *ptr_magdata);
void mag_printtarget(FILE *stream, const magdata_t *ptr_magdata);

#endif /* FF5MAGIC_H */
