/*
 *	ff6magic.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF6MAGIC_H)
#define FF6MAGIC_H

#include "ff6define.h"

typedef struct magdata_tag
{
	int magic_point;			/* ޥåݥ */
	int effect_type;			/* ˡθ̥ */
	int effect_power;			/*  */
	int effect_rate;			/* Ψ */
	int hit_rate;				/* ̿Ψ */
	int effect_level;			/* оݤȤʤŨΥ٥ */
	elem_t elem_effect;			/* ° */
	state_t state_effect;		/* Ѳ */
	int flag_runic;				/* ǵۼǽ */
	int flag_reflect;			/* ե쥯ȿͲǽ */
	int flag_cure;				/* ᡼ʬ */
	int flag_absorb;			/* ᡼ʬۼ */
	int flag_ignore_defense;	/* ɸ/ˡɸϤ̵뤹 */
	int flag_ignore_evade;		/* ˡΨ̵뤹 */
	int flag_physical;			/* ʪǤ(0ʤˡ) */
	int flag_kill;				/* ¨ˡ(¨̵) */
	int flag_state_reset;		/* ֤ */
	int flag_state_reverse;		/* ֤ȿž */
	int flag_ratio;				/* Ψ᡼ */
	int flag_level;				/* ٥ˡ */
	int flag_range_all;			/* ϰϡоݤỤ̃Ρ׸ */
	int flag_roulette;			/* оݤ롼åȤǷޤ */
	int direction;				/* ȯư(0: ̣¦, 1: Ũ¦) */
	int range;					/* ϰ(0: ñ, 1: ) */
	int change_direction;		/* ȯưѲ(0: , 1: ) */
	int change_range;			/* ϰϤѲ(0: , 1: ) */
} magdata_t;

typedef struct espdata_tag
{
	int learn_magic_no[5];		/* Ǥˡ */
	int learn_magic_rate[5];	/* ԡ */
	int lvup_bonus;				/* ٥륢å׻Υܡʥ */
} espdata_t;

const char *mag_getname(int index);
const char *mag_getespname(int index);
magdata_t *mag_readdata(void);
espdata_t *mag_readesp(void);
int mag_writeparam(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writeelem(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writestate(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writeflag(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writeesp(const char *ptr_filename, const espdata_t *ptr_espdata);

#endif /* FF6MAGIC_H */
