/*
 *	ff4character.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF4CHARACTER_H)
#define FF4CHARACTER_H

#define NUM_CHRLV		99
#define NUM_CHRGROWPTN	8

typedef struct chrdata_tag
{
	int chr_name;					/* 饯̾ */
	int chr_job;					/* 饯Υ */
	int initial_level;				/* ٥ */
	long initial_experience_point;	/* и */
	int critical_effect_power;		/* ƥҥåȤθ */
	int critical_hit_rate;			/* ƥҥåΨ */
	int flag_right_hand;			/* ꤬ */
	int flag_left_hand;				/* ꤬ */

	struct
	{
		int increase_strength;		/* Ͼ徺 */
		int increase_speed;			/* ®徺 */
		int increase_stamina;		/* Ͼ徺 */
		int increase_wisdom;		/* 徺 */
		int increase_will_power;	/* 徺 */
	} grow_pattern[NUM_CHRGROWPTN];

	struct
	{
		int item_no;				/* ƥֹ */
		int item_num;				/* Ŀ */
	} equip[5];

	struct
	{
		int hit_point_min,   hit_point_max;		/* ҥåȥݥ */
		int magic_point_min, magic_point_max;	/* ޥåݥ */
		int increase_hit_point_min,   increase_hit_point_max;	/* åҥåȥݥ */
		int increase_magic_point_min, increase_magic_point_max;	/* åޥåݥ */
		long experience_point;		/* и */
		int strength;				/*  */
		int speed;					/* ® */
		int stamina;				/*  */
		int wisdom;					/*  */
		int will_power;				/*  */
	} level[NUM_CHRLV];
} chrdata_t;

const char *chr_getname(int index);
const char *chr_getjobname(int index);
chrdata_t *chr_readdata(void);
int chr_writeparam(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writeequip(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writelvup(const char *ptr_filename, const chrdata_t *ptr_chrdata);

#endif /* FF4CHARACTER_H */
