/*
 *	ff4magic.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF4MAGIC_H)
#define FF4MAGIC_H

#include "ff4define.h"

typedef struct magdata_tag
{
	int magic_point;		/* ޥåݥ */
	int effect_type;		/* ˡθ̥ */
	int effect_power;		/*  */
	int effect_rate;		/* Ψ */
	int hit_rate;			/* ̿Ψ */
	int delay_time;			/* Ե */
	elem_t elem_effect;		/* ° */
	state_t state_effect;	/* Ѳ */
	int flag_boss_noeffect;	/* ܥˤϸ̤ʤ */
	int flag_once;			/* 1˸ꤵ */
	int flag_reflect;		/* ե쥯ȿͲǽ */
	int flag_range_self;	/* ϰϡоݤʬ */
	int direction;			/* ȯư(0: ̣¦, 1: Ũ¦) */
	int range;				/* ϰ(0: ñ, 1: ) */
	int change_direction;	/* ȯưѲ(0: , 1: ) */
	int change_range;		/* ϰϤѲ(0: , 1: ) */
} magdata_t;

const char *mag_getname(int index);
magdata_t *mag_readdata(void);
int mag_setparam(magdata_t *ptr_magdata, unsigned char *ptr_buf, size_t bufsize);
int mag_writeparam(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writeelem(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writestate(const char *ptr_filename, const magdata_t *ptr_magdata);
int mag_writeflag(const char *ptr_filename, const magdata_t *ptr_magdata);
void mag_printtarget(FILE *stream, const magdata_t *ptr_magdata);

#endif /* FF4MAGIC_H */
