/*
 *	ff5special.h
 *		Copyright (C)2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2007-2008 Inu
 */

#if !defined(FF5SPECIAL_H)
#define FF5SPECIAL_H

#include "ff5magic.h"

typedef magdata_t spdata_t;

typedef struct landdata_tag
{
	int effect_no[4];		/* ü칶ֹ */
} landdata_t;

typedef struct mixdata_tag
{
	int item_no[2];			/* 2 फʤǺ */
	int effect_no;			/* Ȥ߹碌ü칶ֹ */
} mixdata_t;

const char *sp_getname(int index);
spdata_t *sp_readdata(void);
landdata_t *sp_readland(void);
mixdata_t *sp_readmix(void);
int sp_writeparam(const char *ptr_filename, const spdata_t *ptr_spdata);
int sp_writeelem(const char *ptr_filename, const spdata_t *ptr_spdata);
int sp_writecategory(const char *ptr_filename, const spdata_t *ptr_spdata);
int sp_writestate(const char *ptr_filename, const spdata_t *ptr_spdata);
int sp_writeflag(const char *ptr_filename, const spdata_t *ptr_spdata);
int sp_writeland(const char *ptr_filename, const landdata_t *ptr_landdata);
int sp_writemix(const char *ptr_filename, const mixdata_t *ptr_mixdata);

#endif /* FF5SPECIAL_H */
