/*
 *	ff6character.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF6CHARACTER_H)
#define FF6CHARACTER_H

#define NUM_CHRLV	99

typedef struct chrdata_tag
{
	int strength;				/*  */
	int speed;					/* ® */
	int stamina;				/*  */
	int magic_power;			/*  */
	int attack_power;			/*  */
	int defense_power;			/* ɸ */
	int evade_rate;				/* Ψ */
	int magic_defense_power;	/* ˡɸ */
	int magic_evade_rate;		/* ˡΨ */
	int level_cng;				/* ٥뽤 */
	int flag_level;				/* ѡƥʿѥ٥˱ƶ뤫 */
	int equipment_no[6];		/* ƥ */
	int cmd_no[4];				/* ޥ */

	struct
	{
		int hit_point;			/* ҥåȥݥ */
		int magic_point;		/* ޥåݥ */
	} level[NUM_CHRLV];
} chrdata_t;

typedef struct chrlvup_tag
{
	long experience_point;	/* и */
	int hit_point;			/* ҥåȥݥ */
	int magic_point;		/* ޥåݥ */
} chrlvup_t;

const char *chr_getname(int index);
const char *chr_getjobname(int index);
const char *chr_getcmdname(int index);
chrdata_t *chr_readdata(void);
chrlvup_t *chr_readlvup(void);
int chr_writeparam(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writeequip(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writecmd(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writelvup(const char *ptr_filename, const chrlvup_t *ptr_chrlvup);

#endif /* FF6CHARACTER_H */
