/*
 *	ff6map.h
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF6MAP_H)
#define FF6MAP_H

#include "ff6define.h"

#define NUM_MAP		433		/* SNES: 414 */

typedef struct mappos_tag
{
	int id;					/* マップ ID */
	size_t x;				/* X 座標 */
	size_t y;				/* Y 座標 */
} mappos_t;

typedef struct mapdata_tag
{
	int sub_no;				/* 名前 */
	int flag_encounter;		/* モンスターと遭遇する */
	int enc_no;				/* モンスター遭遇テーブル番号 */
	int background_no;		/* 戦闘背景 */
	int music_no;			/* 音楽 */
} mapdata_t;

const char *map_getname(int index);
const char *map_getsubname(int index);
mapdata_t *map_readdata(void);

#endif /* FF6MAP_H */
