/*
 *	ff6misc.h
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF6MISC_H)
#define FF6MISC_H

#include "ff6define.h"
#include "ff6item.h"
#include "ff6map.h"
#include "ff6monster.h"

enum treasure_type	/* treasure_tag.type */
{
	TREASURE_TYPE_EMPTY,	/* ä */
	TREASURE_TYPE_BATTLE,	/* 󥹥ȤƮ */
	TREASURE_TYPE_GIL,		/*  */
	TREASURE_TYPE_ITEM,		/* ƥ */
	TREASURE_TYPE_NUM
};

typedef struct treasure_tag
{
	enum treasure_type type;	/* Ȣ */
	union
	{
		long gil;				/*  */
		int battle_no;			/* и󥹥ơֹ֥ */
		int item_no;			/* Ǥ륢ƥֹ */
	} param;

	int id;						/* ID */
	int flag_duplicate;			/* ɤ餫ȢǤʤ */
	mappos_t map;				/* ޥå׺ɸ */
} treasure_t;

treasure_t *tr_readdata(void);
int tr_writedata(const char *ptr_filename, const treasure_t *ptr_trdata, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty);

#endif /* FF6MISC_H */
